/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file           : main.c
  * @brief          : Main program body
  ******************************************************************************
  * @attention
  *
  * <h2><center>&copy; Copyright (c) 2024 STMicroelectronics.
  * All rights reserved.</center></h2>
  *
  * This software component is licensed by ST under Ultimate Liberty license
  * SLA0044, the "License"; You may not use this file except in compliance with
  * the License. You may obtain a copy of the License at:
  *                             www.st.com/SLA0044
  *
  ******************************************************************************
  */
/* USER CODE END Header */
/* Includes ------------------------------------------------------------------*/
#include "main.h"
#include "spi.h"
#include "usb_device.h"
#include "gpio.h"

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */

/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN PTD */

/* USER CODE END PTD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */

/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */

// TFT Chip Select, D/C, Reset
#define CS_LOW      LL_GPIO_ResetOutputPin(TFT_CS_GPIO_Port, TFT_CS_Pin)
#define CS_HIGH     LL_GPIO_SetOutputPin  (TFT_CS_GPIO_Port, TFT_CS_Pin)
#define DC_LOW      LL_GPIO_ResetOutputPin(TFT_CD_GPIO_Port, TFT_CD_Pin)
#define DC_HIGH     LL_GPIO_SetOutputPin  (TFT_CD_GPIO_Port, TFT_CD_Pin)
#define RESET_LOW   LL_GPIO_ResetOutputPin(TFT_RESET_GPIO_Port, TFT_RESET_Pin)
#define RESET_HIGH  LL_GPIO_SetOutputPin  (TFT_RESET_GPIO_Port, TFT_RESET_Pin)

// Touch Chip Select
#define TCS_LOW      LL_GPIO_ResetOutputPin(TOUCH_CS_GPIO_Port, TOUCH_CS_Pin)
#define TCS_HIGH     LL_GPIO_SetOutputPin  (TOUCH_CS_GPIO_Port, TOUCH_CS_Pin)

/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/

/* USER CODE BEGIN PV */

  volatile uint32_t  ticks;
  volatile uint16_t  dly_ticks;
  volatile uint16_t  led_ticks;
  uint16_t pass;

/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/
void SystemClock_Config(void);
/* USER CODE BEGIN PFP */

/* USER CODE END PFP */

/* Private user code ---------------------------------------------------------*/
/* USER CODE BEGIN 0 */

/* FUNCTION ************************************/
void my_touch_irq_handler (void)
/*
 ***********************************************/
{

} /* --- my_touch_irq_handler --- */


/* FUNCTION ************************************/
void my_tick_handler (void)
/*
 ***********************************************/
{
  ticks++;
  led_ticks++;

  if (dly_ticks != 0)  dly_ticks--;

  if (led_ticks == 499)
  {
    LL_GPIO_SetOutputPin(LED_PIN_GPIO_Port, LED_PIN_Pin);
  }
  if (led_ticks == 999)
  {
    LL_GPIO_ResetOutputPin(LED_PIN_GPIO_Port, LED_PIN_Pin);
    led_ticks = 0;
  }

} /* --- my_tick_handler --- */


/* FUNCTION ************************************/
void delay_ms (uint32_t val)
/*
 ***********************************************/
{
  dly_ticks = val;
  while (dly_ticks != 0)
  {
  }

} /* --- delay_ms --- */


/* FUNCTION ************************************/
uint8_t TFTSPI_SPI_xfer (uint8_t val)
/*
 * Single Byte transfer without CS & C/D
 ***********************************************/
{
  static uint8_t  ret;

  while ((SPI1->SR & SPI_SR_TXE) == 0)
  { /*  wait  */  };
  SPI1->DR = val;

  /*  wait for RX not empty  */
  while ((SPI1->SR & SPI_SR_RXNE) == 0)
  { /*  wait  */  };
  ret = SPI1->DR;

  /*  wait for Busy flag not active  */
  while ((SPI1->SR & SPI_SR_BSY) != 0);

  return ret;

} /* --- TFTSPI_SPI_xfer --- */


/* FUNCTION ************************************/
void TFTSPI_SPI_Write (uint8_t *buff, uint16_t count)
/*
 *  Write a complete buffer to SPI with CS
 ***********************************************/
{
  CS_LOW;
  DC_LOW;
  while (count > 0)
  {
    TFTSPI_SPI_xfer (*buff);
    buff++;
    count--;
  }
  CS_HIGH;

} /* --- TFTSPI_SPI_Write --- */


/* USER CODE END 0 */

/**
  * @brief  The application entry point.
  * @retval int
  */
int main(void)
{
  /* USER CODE BEGIN 1 */
  uint8_t mydata[] = {0xAA, 0x55, 0xAA, 0x55};

  /* USER CODE END 1 */

  /* MCU Configuration--------------------------------------------------------*/

  /* Reset of all peripherals, Initializes the Flash interface and the Systick. */
  HAL_Init();

  /* USER CODE BEGIN Init */

  /* USER CODE END Init */

  /* Configure the system clock */
  SystemClock_Config();

  /* USER CODE BEGIN SysInit */

  /* USER CODE END SysInit */

  /* Initialize all configured peripherals */
  MX_GPIO_Init();
  MX_SPI1_Init();
  MX_SPI2_Init();
  MX_USB_DEVICE_Init();
  /* USER CODE BEGIN 2 */

  SPI1_Enable ();   // TFT
  SPI2_Enable ();   // Touch
  RESET_HIGH;       // TFT

  /* USER CODE END 2 */

  /* Infinite loop */
  /* USER CODE BEGIN WHILE */
  while (1)
  {
    /* USER CODE END WHILE */

    /* USER CODE BEGIN 3 */
    pass++;
    delay_ms (50);
    TFTSPI_SPI_Write (mydata, 4);  // mal was auf SPI schreiben
  }
  /* USER CODE END 3 */
}

/**
  * @brief System Clock Configuration
  * @retval None
  */
void SystemClock_Config(void)
{
  LL_FLASH_SetLatency(LL_FLASH_LATENCY_3);
  while(LL_FLASH_GetLatency()!= LL_FLASH_LATENCY_3)
  {
  }
  LL_PWR_SetRegulVoltageScaling(LL_PWR_REGU_VOLTAGE_SCALE1);
  LL_RCC_HSE_Enable();

   /* Wait till HSE is ready */
  while(LL_RCC_HSE_IsReady() != 1)
  {

  }
  LL_RCC_PLL_ConfigDomain_SYS(LL_RCC_PLLSOURCE_HSE, LL_RCC_PLLM_DIV_25, 192, LL_RCC_PLLP_DIV_2);
  LL_RCC_PLL_ConfigDomain_48M(LL_RCC_PLLSOURCE_HSE, LL_RCC_PLLM_DIV_25, 192, LL_RCC_PLLQ_DIV_4);
  LL_RCC_PLL_Enable();

   /* Wait till PLL is ready */
  while(LL_RCC_PLL_IsReady() != 1)
  {

  }
  LL_RCC_SetAHBPrescaler(LL_RCC_SYSCLK_DIV_1);
  LL_RCC_SetAPB1Prescaler(LL_RCC_APB1_DIV_2);
  LL_RCC_SetAPB2Prescaler(LL_RCC_APB2_DIV_1);
  LL_RCC_SetSysClkSource(LL_RCC_SYS_CLKSOURCE_PLL);

   /* Wait till System clock is ready */
  while(LL_RCC_GetSysClkSource() != LL_RCC_SYS_CLKSOURCE_STATUS_PLL)
  {

  }
  LL_SetSystemCoreClock(96000000);

   /* Update the time base */
  if (HAL_InitTick (TICK_INT_PRIORITY) != HAL_OK)
  {
    Error_Handler();
  }
  LL_RCC_SetTIMPrescaler(LL_RCC_TIM_PRESCALER_TWICE);
}

/* USER CODE BEGIN 4 */

/* USER CODE END 4 */

/**
  * @brief  This function is executed in case of error occurrence.
  * @retval None
  */
void Error_Handler(void)
{
  /* USER CODE BEGIN Error_Handler_Debug */
  /* User can add his own implementation to report the HAL error return state */
  __disable_irq();
  while (1)
  {
  }
  /* USER CODE END Error_Handler_Debug */
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t *file, uint32_t line)
{
  /* USER CODE BEGIN 6 */
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  /* USER CODE END 6 */
}
#endif /* USE_FULL_ASSERT */

/************************ (C) COPYRIGHT STMicroelectronics *****END OF FILE****/
